<template>
  <div
    class="input-group"
    :class="{'input-group--error': companyDataErrors[fieldName] !== ''}"
  >
    <label class="input-label">
      {{label}}
    </label>
    <input
      class="input"
      :class="{'input--to-format': companyData[fieldName] !== ''}"
      @blur="handleBlur"
      v-model="fieldModel"
      :placeholder="placeholder"
      v-bind="aditionalProps"
    />
    <p
      v-show="companyData[fieldName] !== ''"
      class="input input--formatted"
    >
      {{formatValue(companyData[fieldName])}}
    </p>
  </div>
</template>

<script>
import { mapGetters, mapActions } from 'vuex';

export default {
  name: "FormattedInput",
  props: {
    fieldName: String,
    label: String,
    placeholder: String,
    formatValue: {
      type: Function,
      default: value => value,
    },
    aditionalProps: {
      type: Object,
      default: () => ({
        type: 'text',
      }),
    },
  },
  methods: {
    ...mapActions(['updateCompanyField', 'validateField']),
    handleBlur() {
      this.validateField(this.fieldName);
    },
  },
  computed: {
    ...mapGetters(['companyData', 'companyDataErrors']),
    fieldModel: {
      get () {
        return this.companyData[this.fieldName];
      },
      set (fieldValue) {
        this.updateCompanyField({fieldName: this.fieldName, fieldValue});
      }
    }
  }
}
</script>

<style lang="scss" scoped>
  @import 'Styles/components/input.scss';
</style>

